# coding: utf-8

"""
    Mozart platform API

    API for interacting with the Mozart platform.

    The version of the OpenAPI document: 0.2.0
    Contact: support@bang-olufsen.dk
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr, conint


class PairedRemote(BaseModel):
    """
    PairedRemote
    """

    address: StrictStr = Field(...)
    battery_level: Optional[conint(strict=True, le=100, ge=0)] = Field(
        None, alias="batteryLevel"
    )
    name: StrictStr = Field(...)
    __properties = ["address", "batteryLevel", "name"]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PairedRemote:
        """Create an instance of PairedRemote from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PairedRemote:
        """Create an instance of PairedRemote from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PairedRemote.parse_obj(obj)

        _obj = PairedRemote.parse_obj(
            {
                "address": obj.get("address"),
                "battery_level": obj.get("batteryLevel"),
                "name": obj.get("name"),
            }
        )
        return _obj
